Merge tag 'l10n-2.4-maint-de-updates' of git://github.com/git-l10n/git-po into maint
[git.git] / git-am.sh
bloba67d0f98989706fa69df4cf7d6242ad9531eb337
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_STUCKLONG=t
8 OPTIONS_SPEC="\
9 git am [options] [(<mbox>|<Maildir>)...]
10 git am [options] (--continue | --skip | --abort)
12 i,interactive run interactively
13 b,binary* (historical option -- no-op)
14 3,3way allow fall back on 3way merging if needed
15 q,quiet be quiet
16 s,signoff add a Signed-off-by line to the commit message
17 u,utf8 recode into utf8 (default)
18 k,keep pass -k flag to git-mailinfo
19 keep-non-patch pass -b flag to git-mailinfo
20 m,message-id pass -m flag to git-mailinfo
21 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
22 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
23 c,scissors strip everything before a scissors line
24 whitespace= pass it through git-apply
25 ignore-space-change pass it through git-apply
26 ignore-whitespace pass it through git-apply
27 directory= pass it through git-apply
28 exclude= pass it through git-apply
29 include= pass it through git-apply
30 C= pass it through git-apply
31 p= pass it through git-apply
32 patch-format= format the patch(es) are in
33 reject pass it through git-apply
34 resolvemsg= override error message when patch failure occurs
35 continue continue applying patches after resolving a conflict
36 r,resolved synonyms for --continue
37 skip skip the current patch
38 abort restore the original branch and abort the patching operation.
39 committer-date-is-author-date lie about committer date
40 ignore-date use current timestamp for author date
41 rerere-autoupdate update the index with reused conflict resolution if possible
42 S,gpg-sign? GPG-sign commits
43 rebasing* (internal use for git-rebase)"
45 . git-sh-setup
46 . git-sh-i18n
47 prefix=$(git rev-parse --show-prefix)
48 set_reflog_action am
49 require_work_tree
50 cd_to_toplevel
52 git var GIT_COMMITTER_IDENT >/dev/null ||
53 die "$(gettext "You need to set your committer info first")"
55 if git rev-parse --verify -q HEAD >/dev/null
56 then
57 HAS_HEAD=yes
58 else
59 HAS_HEAD=
62 cmdline="git am"
63 if test '' != "$interactive"
64 then
65 cmdline="$cmdline -i"
67 if test '' != "$threeway"
68 then
69 cmdline="$cmdline -3"
72 sq () {
73 git rev-parse --sq-quote "$@"
76 stop_here () {
77 echo "$1" >"$dotest/next"
78 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
79 exit 1
82 safe_to_abort () {
83 if test -f "$dotest/dirtyindex"
84 then
85 return 1
88 if ! test -s "$dotest/abort-safety"
89 then
90 return 0
93 abort_safety=$(cat "$dotest/abort-safety")
94 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
95 then
96 return 0
98 gettextln "You seem to have moved HEAD since the last 'am' failure.
99 Not rewinding to ORIG_HEAD" >&2
100 return 1
103 stop_here_user_resolve () {
104 if [ -n "$resolvemsg" ]; then
105 printf '%s\n' "$resolvemsg"
106 stop_here $1
108 eval_gettextln "When you have resolved this problem, run \"\$cmdline --continue\".
109 If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
110 To restore the original branch and stop patching, run \"\$cmdline --abort\"."
112 stop_here $1
115 go_next () {
116 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
117 "$dotest/patch" "$dotest/info"
118 echo "$next" >"$dotest/next"
119 this=$next
122 cannot_fallback () {
123 echo "$1"
124 gettextln "Cannot fall back to three-way merge."
125 exit 1
128 fall_back_3way () {
129 O_OBJECT=$(cd "$GIT_OBJECT_DIRECTORY" && pwd)
131 rm -fr "$dotest"/patch-merge-*
132 mkdir "$dotest/patch-merge-tmp-dir"
134 # First see if the patch records the index info that we can use.
135 cmd="git apply $git_apply_opt --build-fake-ancestor" &&
136 cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
137 eval "$cmd" &&
138 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
139 git write-tree >"$dotest/patch-merge-base+" ||
140 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
142 say "$(gettext "Using index info to reconstruct a base tree...")"
144 cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
146 if test -z "$GIT_QUIET"
147 then
148 eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
151 cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
152 if eval "$cmd"
153 then
154 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
155 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
156 else
157 cannot_fallback "$(gettext "Did you hand edit your patch?
158 It does not apply to blobs recorded in its index.")"
161 test -f "$dotest/patch-merge-index" &&
162 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
163 orig_tree=$(cat "$dotest/patch-merge-base") &&
164 rm -fr "$dotest"/patch-merge-* || exit 1
166 say "$(gettext "Falling back to patching base and 3-way merge...")"
168 # This is not so wrong. Depending on which base we picked,
169 # orig_tree may be wildly different from ours, but his_tree
170 # has the same set of wildly different changes in parts the
171 # patch did not touch, so recursive ends up canceling them,
172 # saying that we reverted all those changes.
174 eval GITHEAD_$his_tree='"$FIRSTLINE"'
175 export GITHEAD_$his_tree
176 if test -n "$GIT_QUIET"
177 then
178 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
180 git-merge-recursive $orig_tree -- HEAD $his_tree || {
181 git rerere $allow_rerere_autoupdate
182 die "$(gettext "Failed to merge in the changes.")"
184 unset GITHEAD_$his_tree
187 clean_abort () {
188 test $# = 0 || echo >&2 "$@"
189 rm -fr "$dotest"
190 exit 1
193 patch_format=
195 check_patch_format () {
196 # early return if patch_format was set from the command line
197 if test -n "$patch_format"
198 then
199 return 0
202 # we default to mbox format if input is from stdin and for
203 # directories
204 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
205 then
206 patch_format=mbox
207 return 0
210 # otherwise, check the first few non-blank lines of the first
211 # patch to try to detect its format
213 # Start from first line containing non-whitespace
215 while test -z "$l1"
217 read l1 || break
218 done
219 read l2
220 read l3
221 case "$l1" in
222 "From "* | "From: "*)
223 patch_format=mbox
225 '# This series applies on GIT commit'*)
226 patch_format=stgit-series
228 "# HG changeset patch")
229 patch_format=hg
232 # if the second line is empty and the third is
233 # a From, Author or Date entry, this is very
234 # likely an StGIT patch
235 case "$l2,$l3" in
236 ,"From: "* | ,"Author: "* | ,"Date: "*)
237 patch_format=stgit
241 esac
243 esac
244 if test -z "$patch_format" &&
245 test -n "$l1" &&
246 test -n "$l2" &&
247 test -n "$l3"
248 then
249 # This begins with three non-empty lines. Is this a
250 # piece of e-mail a-la RFC2822? Grab all the headers,
251 # discarding the indented remainder of folded lines,
252 # and see if it looks like that they all begin with the
253 # header field names...
254 tr -d '\015' <"$1" |
255 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
256 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
257 patch_format=mbox
259 } < "$1" || clean_abort
262 split_patches () {
263 case "$patch_format" in
264 mbox)
265 if test t = "$keepcr"
266 then
267 keep_cr=--keep-cr
268 else
269 keep_cr=
271 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
272 clean_abort
274 stgit-series)
275 if test $# -ne 1
276 then
277 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
279 series_dir=$(dirname "$1")
280 series_file="$1"
281 shift
283 set x
284 while read filename
286 set "$@" "$series_dir/$filename"
287 done
288 # remove the safety x
289 shift
290 # remove the arg coming from the first-line comment
291 shift
292 } < "$series_file" || clean_abort
293 # set the patch format appropriately
294 patch_format=stgit
295 # now handle the actual StGIT patches
296 split_patches "$@"
298 stgit)
299 this=0
300 for stgit in "$@"
302 this=$(expr "$this" + 1)
303 msgnum=$(printf "%0${prec}d" $this)
304 # Perl version of StGIT parse_patch. The first nonemptyline
305 # not starting with Author, From or Date is the
306 # subject, and the body starts with the next nonempty
307 # line not starting with Author, From or Date
308 @@PERL@@ -ne 'BEGIN { $subject = 0 }
309 if ($subject > 1) { print ; }
310 elsif (/^\s+$/) { next ; }
311 elsif (/^Author:/) { s/Author/From/ ; print ;}
312 elsif (/^(From|Date)/) { print ; }
313 elsif ($subject) {
314 $subject = 2 ;
315 print "\n" ;
316 print ;
317 } else {
318 print "Subject: ", $_ ;
319 $subject = 1;
321 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
322 done
323 echo "$this" > "$dotest/last"
324 this=
325 msgnum=
328 this=0
329 for hg in "$@"
331 this=$(( $this + 1 ))
332 msgnum=$(printf "%0${prec}d" $this)
333 # hg stores changeset metadata in #-commented lines preceding
334 # the commit message and diff(s). The only metadata we care about
335 # are the User and Date (Node ID and Parent are hashes which are
336 # only relevant to the hg repository and thus not useful to us)
337 # Since we cannot guarantee that the commit message is in
338 # git-friendly format, we put no Subject: line and just consume
339 # all of the message as the body
340 LANG=C LC_ALL=C @@PERL@@ -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
341 if ($subject) { print ; }
342 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
343 elsif (/^\# Date /) {
344 my ($hashsign, $str, $time, $tz) = split ;
345 $tz = sprintf "%+05d", (0-$tz)/36;
346 print "Date: " .
347 strftime("%a, %d %b %Y %H:%M:%S ",
348 localtime($time))
349 . "$tz\n";
350 } elsif (/^\# /) { next ; }
351 else {
352 print "\n", $_ ;
353 $subject = 1;
355 ' <"$hg" >"$dotest/$msgnum" || clean_abort
356 done
357 echo "$this" >"$dotest/last"
358 this=
359 msgnum=
362 if test -n "$patch_format"
363 then
364 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
365 else
366 clean_abort "$(gettext "Patch format detection failed.")"
369 esac
372 prec=4
373 dotest="$GIT_DIR/rebase-apply"
374 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
375 messageid= resolvemsg= resume= scissors= no_inbody_headers=
376 git_apply_opt=
377 committer_date_is_author_date=
378 ignore_date=
379 allow_rerere_autoupdate=
380 gpg_sign_opt=
382 if test "$(git config --bool --get am.messageid)" = true
383 then
384 messageid=t
387 if test "$(git config --bool --get am.keepcr)" = true
388 then
389 keepcr=t
392 while test $# != 0
394 case "$1" in
395 -i|--interactive)
396 interactive=t ;;
397 -b|--binary)
398 gettextln >&2 "The -b/--binary option has been a no-op for long time, and
399 it will be removed. Please do not use it anymore."
401 -3|--3way)
402 threeway=t ;;
403 -s|--signoff)
404 sign=t ;;
405 -u|--utf8)
406 utf8=t ;; # this is now default
407 --no-utf8)
408 utf8= ;;
409 -m|--message-id)
410 messageid=t ;;
411 --no-message-id)
412 messageid=f ;;
413 -k|--keep)
414 keep=t ;;
415 --keep-non-patch)
416 keep=b ;;
417 -c|--scissors)
418 scissors=t ;;
419 --no-scissors)
420 scissors=f ;;
421 -r|--resolved|--continue)
422 resolved=t ;;
423 --skip)
424 skip=t ;;
425 --abort)
426 abort=t ;;
427 --rebasing)
428 rebasing=t threeway=t ;;
429 --resolvemsg=*)
430 resolvemsg="${1#--resolvemsg=}" ;;
431 --whitespace=*|--directory=*|--exclude=*|--include=*)
432 git_apply_opt="$git_apply_opt $(sq "$1")" ;;
433 -C*|-p*)
434 git_apply_opt="$git_apply_opt $(sq "$1")" ;;
435 --patch-format=*)
436 patch_format="${1#--patch-format=}" ;;
437 --reject|--ignore-whitespace|--ignore-space-change)
438 git_apply_opt="$git_apply_opt $1" ;;
439 --committer-date-is-author-date)
440 committer_date_is_author_date=t ;;
441 --ignore-date)
442 ignore_date=t ;;
443 --rerere-autoupdate|--no-rerere-autoupdate)
444 allow_rerere_autoupdate="$1" ;;
445 -q|--quiet)
446 GIT_QUIET=t ;;
447 --keep-cr)
448 keepcr=t ;;
449 --no-keep-cr)
450 keepcr=f ;;
451 --gpg-sign)
452 gpg_sign_opt=-S ;;
453 --gpg-sign=*)
454 gpg_sign_opt="-S${1#--gpg-sign=}" ;;
456 shift; break ;;
458 usage ;;
459 esac
460 shift
461 done
463 # If the dotest directory exists, but we have finished applying all the
464 # patches in them, clear it out.
465 if test -d "$dotest" &&
466 test -f "$dotest/last" &&
467 test -f "$dotest/next" &&
468 last=$(cat "$dotest/last") &&
469 next=$(cat "$dotest/next") &&
470 test $# != 0 &&
471 test "$next" -gt "$last"
472 then
473 rm -fr "$dotest"
476 if test -d "$dotest" && test -f "$dotest/last" && test -f "$dotest/next"
477 then
478 case "$#,$skip$resolved$abort" in
479 0,*t*)
480 # Explicit resume command and we do not have file, so
481 # we are happy.
482 : ;;
484 # No file input but without resume parameters; catch
485 # user error to feed us a patch from standard input
486 # when there is already $dotest. This is somewhat
487 # unreliable -- stdin could be /dev/null for example
488 # and the caller did not intend to feed us a patch but
489 # wanted to continue unattended.
490 test -t 0
493 false
495 esac ||
496 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
497 resume=yes
499 case "$skip,$abort" in
500 t,t)
501 die "$(gettext "Please make up your mind. --skip or --abort?")"
504 git rerere clear
505 git read-tree --reset -u HEAD HEAD
506 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
507 git reset HEAD
508 git update-ref ORIG_HEAD $orig_head
511 if test -f "$dotest/rebasing"
512 then
513 exec git rebase --abort
515 git rerere clear
516 if safe_to_abort
517 then
518 git read-tree --reset -u HEAD ORIG_HEAD
519 git reset ORIG_HEAD
521 rm -fr "$dotest"
522 exit ;;
523 esac
524 rm -f "$dotest/dirtyindex"
525 else
526 # Possible stray $dotest directory in the independent-run
527 # case; in the --rebasing case, it is upto the caller
528 # (git-rebase--am) to take care of stray directories.
529 if test -d "$dotest" && test -z "$rebasing"
530 then
531 case "$skip,$resolved,$abort" in
532 ,,t)
533 rm -fr "$dotest"
534 exit 0
537 die "$(eval_gettext "Stray \$dotest directory found.
538 Use \"git am --abort\" to remove it.")"
540 esac
543 # Make sure we are not given --skip, --continue, or --abort
544 test "$skip$resolved$abort" = "" ||
545 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
547 # Start afresh.
548 mkdir -p "$dotest" || exit
550 if test -n "$prefix" && test $# != 0
551 then
552 first=t
553 for arg
555 test -n "$first" && {
556 set x
557 first=
559 if is_absolute_path "$arg"
560 then
561 set "$@" "$arg"
562 else
563 set "$@" "$prefix$arg"
565 done
566 shift
569 check_patch_format "$@"
571 split_patches "$@"
573 # -i can and must be given when resuming; everything
574 # else is kept
575 echo " $git_apply_opt" >"$dotest/apply-opt"
576 echo "$threeway" >"$dotest/threeway"
577 echo "$sign" >"$dotest/sign"
578 echo "$utf8" >"$dotest/utf8"
579 echo "$keep" >"$dotest/keep"
580 echo "$messageid" >"$dotest/messageid"
581 echo "$scissors" >"$dotest/scissors"
582 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
583 echo "$GIT_QUIET" >"$dotest/quiet"
584 echo 1 >"$dotest/next"
585 if test -n "$rebasing"
586 then
587 : >"$dotest/rebasing"
588 else
589 : >"$dotest/applying"
590 if test -n "$HAS_HEAD"
591 then
592 git update-ref ORIG_HEAD HEAD
593 else
594 git update-ref -d ORIG_HEAD >/dev/null 2>&1
599 git update-index -q --refresh
601 case "$resolved" in
603 case "$HAS_HEAD" in
605 files=$(git ls-files) ;;
607 files=$(git diff-index --cached --name-only HEAD --) ;;
608 esac || exit
609 if test "$files"
610 then
611 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
612 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
614 esac
616 # Now, decide what command line options we will give to the git
617 # commands we invoke, based on the result of parsing command line
618 # options and previous invocation state stored in $dotest/ files.
620 if test "$(cat "$dotest/utf8")" = t
621 then
622 utf8=-u
623 else
624 utf8=-n
626 keep=$(cat "$dotest/keep")
627 case "$keep" in
629 keep=-k ;;
631 keep=-b ;;
633 keep= ;;
634 esac
635 case "$(cat "$dotest/messageid")" in
637 messageid=-m ;;
639 messageid= ;;
640 esac
641 case "$(cat "$dotest/scissors")" in
643 scissors=--scissors ;;
645 scissors=--no-scissors ;;
646 esac
647 if test "$(cat "$dotest/no_inbody_headers")" = t
648 then
649 no_inbody_headers=--no-inbody-headers
650 else
651 no_inbody_headers=
653 if test "$(cat "$dotest/quiet")" = t
654 then
655 GIT_QUIET=t
657 if test "$(cat "$dotest/threeway")" = t
658 then
659 threeway=t
661 git_apply_opt=$(cat "$dotest/apply-opt")
662 if test "$(cat "$dotest/sign")" = t
663 then
664 SIGNOFF=$(git var GIT_COMMITTER_IDENT | sed -e '
665 s/>.*/>/
666 s/^/Signed-off-by: /'
668 else
669 SIGNOFF=
672 last=$(cat "$dotest/last")
673 this=$(cat "$dotest/next")
674 if test "$skip" = t
675 then
676 this=$(expr "$this" + 1)
677 resume=
680 while test "$this" -le "$last"
682 msgnum=$(printf "%0${prec}d" $this)
683 next=$(expr "$this" + 1)
684 test -f "$dotest/$msgnum" || {
685 resume=
686 go_next
687 continue
690 # If we are not resuming, parse and extract the patch information
691 # into separate files:
692 # - info records the authorship and title
693 # - msg is the rest of commit log message
694 # - patch is the patch body.
696 # When we are resuming, these files are either already prepared
697 # by the user, or the user can tell us to do so by --continue flag.
698 case "$resume" in
700 if test -f "$dotest/rebasing"
701 then
702 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
703 -e q "$dotest/$msgnum") &&
704 test "$(git cat-file -t "$commit")" = commit ||
705 stop_here $this
706 git cat-file commit "$commit" |
707 sed -e '1,/^$/d' >"$dotest/msg-clean"
708 echo "$commit" >"$dotest/original-commit"
709 get_author_ident_from_commit "$commit" >"$dotest/author-script"
710 git diff-tree --root --binary --full-index "$commit" >"$dotest/patch"
711 else
712 git mailinfo $keep $no_inbody_headers $messageid $scissors $utf8 "$dotest/msg" "$dotest/patch" \
713 <"$dotest/$msgnum" >"$dotest/info" ||
714 stop_here $this
716 # skip pine's internal folder data
717 sane_grep '^Author: Mail System Internal Data$' \
718 <"$dotest"/info >/dev/null &&
719 go_next && continue
721 test -s "$dotest/patch" || {
722 eval_gettextln "Patch is empty. Was it split wrong?
723 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
724 To restore the original branch and stop patching run \"\$cmdline --abort\"."
725 stop_here $this
727 rm -f "$dotest/original-commit" "$dotest/author-script"
729 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
730 echo
731 cat "$dotest/msg"
733 git stripspace > "$dotest/msg-clean"
736 esac
738 if test -f "$dotest/author-script"
739 then
740 eval $(cat "$dotest/author-script")
741 else
742 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
743 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
744 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
747 if test -z "$GIT_AUTHOR_EMAIL"
748 then
749 gettextln "Patch does not have a valid e-mail address."
750 stop_here $this
753 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
755 case "$resume" in
757 if test '' != "$SIGNOFF"
758 then
759 LAST_SIGNED_OFF_BY=$(
760 sed -ne '/^Signed-off-by: /p' \
761 "$dotest/msg-clean" |
762 sed -ne '$p'
764 ADD_SIGNOFF=$(
765 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
766 test '' = "$LAST_SIGNED_OFF_BY" && echo
767 echo "$SIGNOFF"
769 else
770 ADD_SIGNOFF=
773 if test -s "$dotest/msg-clean"
774 then
775 cat "$dotest/msg-clean"
777 if test '' != "$ADD_SIGNOFF"
778 then
779 echo "$ADD_SIGNOFF"
781 } >"$dotest/final-commit"
784 case "$resolved$interactive" in
786 # This is used only for interactive view option.
787 git diff-index -p --cached HEAD -- >"$dotest/patch"
789 esac
790 esac
792 resume=
793 if test "$interactive" = t
794 then
795 test -t 0 ||
796 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
797 action=again
798 while test "$action" = again
800 gettextln "Commit Body is:"
801 echo "--------------------------"
802 cat "$dotest/final-commit"
803 echo "--------------------------"
804 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
805 # in your translation. The program will only accept English
806 # input at this point.
807 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
808 read reply
809 case "$reply" in
810 [yY]*) action=yes ;;
811 [aA]*) action=yes interactive= ;;
812 [nN]*) action=skip ;;
813 [eE]*) git_editor "$dotest/final-commit"
814 action=again ;;
815 [vV]*) action=again
816 git_pager "$dotest/patch" ;;
817 *) action=again ;;
818 esac
819 done
820 else
821 action=yes
824 if test $action = skip
825 then
826 go_next
827 continue
830 if test -x "$GIT_DIR"/hooks/applypatch-msg
831 then
832 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
833 stop_here $this
836 if test -f "$dotest/final-commit"
837 then
838 FIRSTLINE=$(sed 1q "$dotest/final-commit")
839 else
840 FIRSTLINE=""
843 say "$(eval_gettext "Applying: \$FIRSTLINE")"
845 case "$resolved" in
847 # When we are allowed to fall back to 3-way later, don't give
848 # false errors during the initial attempt.
849 squelch=
850 if test "$threeway" = t
851 then
852 squelch='>/dev/null 2>&1 '
854 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
855 apply_status=$?
858 # Resolved means the user did all the hard work, and
859 # we do not have to do any patch application. Just
860 # trust what the user has in the index file and the
861 # working tree.
862 resolved=
863 git diff-index --quiet --cached HEAD -- && {
864 gettextln "No changes - did you forget to use 'git add'?
865 If there is nothing left to stage, chances are that something else
866 already introduced the same changes; you might want to skip this patch."
867 stop_here_user_resolve $this
869 unmerged=$(git ls-files -u)
870 if test -n "$unmerged"
871 then
872 gettextln "You still have unmerged paths in your index
873 did you forget to use 'git add'?"
874 stop_here_user_resolve $this
876 apply_status=0
877 git rerere
879 esac
881 if test $apply_status != 0 && test "$threeway" = t
882 then
883 if (fall_back_3way)
884 then
885 # Applying the patch to an earlier tree and merging the
886 # result may have produced the same tree as ours.
887 git diff-index --quiet --cached HEAD -- && {
888 say "$(gettext "No changes -- Patch already applied.")"
889 go_next
890 continue
892 # clear apply_status -- we have successfully merged.
893 apply_status=0
896 if test $apply_status != 0
897 then
898 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
899 if test "$(git config --bool advice.amworkdir)" != false
900 then
901 eval_gettextln 'The copy of the patch that failed is found in:
902 $dotest/patch'
904 stop_here_user_resolve $this
907 if test -x "$GIT_DIR"/hooks/pre-applypatch
908 then
909 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
912 tree=$(git write-tree) &&
913 commit=$(
914 if test -n "$ignore_date"
915 then
916 GIT_AUTHOR_DATE=
918 parent=$(git rev-parse --verify -q HEAD) ||
919 say >&2 "$(gettext "applying to an empty history")"
921 if test -n "$committer_date_is_author_date"
922 then
923 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
924 export GIT_COMMITTER_DATE
925 fi &&
926 git commit-tree ${parent:+-p} $parent ${gpg_sign_opt:+"$gpg_sign_opt"} $tree \
927 <"$dotest/final-commit"
928 ) &&
929 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
930 stop_here $this
932 if test -f "$dotest/original-commit"; then
933 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
936 if test -x "$GIT_DIR"/hooks/post-applypatch
937 then
938 "$GIT_DIR"/hooks/post-applypatch
941 go_next
942 done
944 if test -s "$dotest"/rewritten; then
945 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
946 if test -x "$GIT_DIR"/hooks/post-rewrite; then
947 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
951 # If am was called with --rebasing (from git-rebase--am), it's up to
952 # the caller to take care of housekeeping.
953 if ! test -f "$dotest/rebasing"
954 then
955 rm -fr "$dotest"
956 git gc --auto